<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.15" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="indexpage" kind="group">
    <compoundname>index</compoundname>
    <title>Overview</title>
    <briefdescription>
    </briefdescription>
    <detaileddescription>
<para>This document lists the Application Programming Interfaces exposed by BTSTACK library for Application developers to use and create BLE or BR/EDR or Dual Mode (BLE+BR/EDR) Applications. BTSTACK library is used in conjuction with a porting layer such as the <ulink url="https://github.com/cypresssemiconductorco/bluetooth-freertos">one available for FreeRTOS on PSOC</ulink>.</para>
<para>Typical steps in using BTSTACK library APIs are -</para>
<para><heading level="2">Initialization</heading>
</para>
<para><itemizedlist>
<listitem><para>The application thread typically starts the bluetooth stack with a call to <ref kindref="member" refid="group__wiced__bt__cfg_1gabac5a1c3126b145f079c6797790844af">wiced_bt_stack_init</ref>.</para>
</listitem><listitem><para>The application then waits for the BTM_ENABLED event received through the registered callback</para>
</listitem><listitem><para>Further interaction with the stack may be done in the same thread context in case of single threaded or in an application thread.</para>
</listitem></itemizedlist>
</para>
<para><heading level="2">Configuration Settings</heading>
</para>
<para><itemizedlist>
<listitem><para>An application provides stack configuration parameters via <ref kindref="compound" refid="structwiced__bt__cfg__settings__t">wiced_bt_cfg_settings_t</ref> configuration structure. These are typically non-changing during the lifetime of the application. These include among others<itemizedlist>
<listitem><para>The max number of links the application is expected to setup across both physical layers (LE and BR/EDR) and logical layers (GATT, L2CAP, other protocols and profiles)</para>
</listitem><listitem><para>The protocol/profile specific configurable settings.</para>
</listitem><listitem><para>For a full set of the configurable settings please refere to <ulink url="https://cypresssemiconductorco.github.io/btstack/api_reference_manual/html/modules.html">API reference</ulink></para>
</listitem></itemizedlist>
</para>
</listitem></itemizedlist>
</para>
<para><heading level="2">Gatt Database</heading>
</para>
<para><itemizedlist>
<listitem><para>For all GATT server applications, the application is expected to setup a GATT database.</para>
</listitem><listitem><para>The GATT database is typically created using the BT Configurator tool</para>
</listitem><listitem><para>This GATT database will be queried by the remote GATT client device during the GATT discover procedure</para>
</listitem></itemizedlist>
</para>
<para><heading level="2">Callbacks</heading>
</para>
<para><itemizedlist>
<listitem><para>The application sets up callbacks with the BTSTACK Library.<itemizedlist>
<listitem><para>For receiving Bluetooth link and general device management callbacks, appliation registers a callback using <ref kindref="member" refid="group__wiced__bt__cfg_1gabac5a1c3126b145f079c6797790844af">wiced_bt_stack_init</ref></para>
</listitem><listitem><para>For the GATT applications a GATT callback function is registered using the call to wiced_bt_gatt_register. </para>
</listitem></itemizedlist>
</para>
</listitem></itemizedlist>
</para>
    </detaileddescription>
  </compounddef>
</doxygen>